Subject: Re: [MMUSIC] [Fwd: I-D ACTION:draft-ietf-mmusic-file-transfer-mech-00.txt]

From: Aki Niemi <[email-masked]>
Date: Fri, 09 Feb 2007 12:49:35 +0200

Hi Miguel,

Skimming through the draft, the MSRP usage caught my attention.
Currently, at least in the examples in Section 9, the MSRP usage defines
a synchronous scheme for sending chunks over MSRP. It appears this
scheme will have quite poor performance. This is because you need to
wait a round-trip between consecutive chunks, which means that the
overall transfer rate will in most cases be poor, depending of course on
the network latency.

The way file transfers should work is that the requests are pipelined
much like in HTTP/1.1, i.e., a certain number of SENDs are sent without
first waiting for a response. However, I'm not sure MSRP actually
supports this. The MSRP draft seems to be silent on this issue.

Anyway, I think it should be said somewhere, that for MSRP file
transfers, pipelining SEND requests is RECOMMENDED. Maybe even throw in
a recommended number of SENDs to have outstanding at a time in such
pipelining bursts.

Cheers,
Aki

ext Miguel Garcia wrote:
> As you can see, there is a new version of the SDP O/A for file transfer
> draft. There are no technical changes in this version of the spec, just
> the IANA considerations section got updated.
> 
> /Miguel
> 
> ------------------------------------------------------------------------
> 
> Subject:
> I-D ACTION:draft-ietf-mmusic-file-transfer-mech-00.txt
> From:
> "ext [email-masked]" <[email-masked]>
> Date:
> Mon, 18 Dec 2006 15:50:01 -0500
> To:
> [email-masked]
> 
> To:
> [email-masked]
> CC:
> [email-masked]
> 
> 
> A New Internet-Draft is available from the on-line Internet-Drafts 
> directories.
> This draft is a work item of the Multiparty Multimedia Session Control Working Group of the IETF.
> 
> 	Title		: A Session Description Protocol (SDP) Offer/Answer Mechanism to Enable File Transfer
> 	Author(s)	: M. Garcia-Martin, et al.
> 	Filename	: draft-ietf-mmusic-file-transfer-mech-00.txt
> 	Pages		: 35
> 	Date		: 2006-12-18
> 	
>    This document provides a mechanism to negotiate the transfer of one
>    or more files between two endpoints by using the Session Description
>    Protocol (SDP) offer/answer model specified in RFC 3264.  SDP is
>    extended to describe the attributes of the files to be transferred.
>    The offerer can either describe the files it wants to send, or the
>    files it would like to receive.  The answerer can either accept or
>    reject the offer separately for each individual file .  The transfer
>    of one or more files is initiated after a successful negotiation.
>    The Message Session Relay Protocol (MSRP) is defined as the default
>    mechanism to actually carry the files between the endpoints.  The
>    conventions on how to use MSRP for file transfer are also provided in
>    this document.
> 
> 
> A URL for this Internet-Draft is:
> http://www.ietf.org/internet-drafts/draft-ietf-mmusic-file-transfer-mech-00.txt
> 
> To remove yourself from the I-D Announcement list, send a message to 
> [email-masked] with the word unsubscribe in the body of 
> the message. 
> You can also visit https://www1.ietf.org/mailman/listinfo/I-D-announce 
> to change your subscription settings.
> 
> Internet-Drafts are also available by anonymous FTP. Login with the 
> username "anonymous" and a password of your e-mail address. After 
> logging in, type "cd internet-drafts" and then 
> "get draft-ietf-mmusic-file-transfer-mech-00.txt".
> 
> A list of Internet-Drafts directories can be found in
> http://www.ietf.org/shadow.html 
> or ftp://ftp.ietf.org/ietf/1shadow-sites.txt
> 
> Internet-Drafts can also be obtained by e-mail.
> 
> Send a message to:
> 	[email-masked].
> In the body type:
> 	"FILE /internet-drafts/draft-ietf-mmusic-file-transfer-mech-00.txt".
> 	
> NOTE:	The mail server at ietf.org can return the document in
> 	MIME-encoded form by using the "mpack" utility.  To use this
> 	feature, insert the command "ENCODING mime" before the "FILE"
> 	command.  To decode the response(s), you will need "munpack" or
> 	a MIME-compliant mail reader.  Different MIME-compliant mail readers
> 	exhibit different behavior, especially when dealing with
> 	"multipart" MIME messages (i.e. documents which have been split
> 	up into multiple messages), so check your local documentation on
> 	how to manipulate these messages.
> 
> Below is the data which will enable a MIME compliant mail reader
> implementation to automatically retrieve the ASCII version of the
> Internet-Draft.
> 
> 
> ------------------------------------------------------------------------
> 
> _______________________________________________
> I-D-Announce mailing list
> [email-masked]
> https://www1.ietf.org/mailman/listinfo/i-d-announce

_______________________________________________
mmusic mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mmusic

---

From: Miguel Garcia <[email-masked]>
Date: Fri, 09 Feb 2007 13:28:42 +0200

Aki:

Yes, I agree with you, the MSRP SEND request should be sent one after 
each other. Bear in mind, also, that the idea of the draft is to use 
MSRP "as is", with no changes.

The examples section is inspired in the Examples Section 11 in the MSRP 
draft,

http://www.ietf.org/internet-drafts/draft-ietf-simple-message-sessions-18.txt

Somehow, we got confused by the examples in there...

So, can you please point out if there are any suggestions for the file 
transfer draft, or are those suggestions for MSRP? Especially, I 
wouldn't dare to recommend to pipeline MSRP send requests or how many of 
them, because as I said, we want to use off-the-shelf MSRP. But perhaps 
you should post something in SIMPLE and to the MSRP authors.

We can still change the example to show pipelined MSRP SEND requests.

/Miguel

-- 
Miguel A. Garcia           tel:+358-50-4804586
sip:[email-masked]
Nokia Research Center      Helsinki, Finland

---

From: Ben Campbell <[email-masked]>
Date: Fri, 9 Feb 2007 06:56:58 -0800

To my knowledge, there is no prohibition against pipelining in MSRP.  
(I say to my knowledge because we have been working on that draft so  
long I sometimes forget what is in there--please point it out to me  
if you find one :-) )

I'm not sure pipelining will have as big of an impact as you might  
think, since you are recommended to keep chunks as large as   
reasonably possible. The 2048 limit on chunks is not a limit as to  
how big a chunk can be, it's a limit on how large a chunk can be  
without being interruptible. The idea is you send as big of a chunk  
as you can, then interrupt it if needed.

So in the file transfer scenario, assuming chunks don't get  
interrupted very often, a file transfer may have a fairly small  
number of chunks.

On Feb 9, 2007, at 3:28 AM, Miguel Garcia wrote:

> Aki:
>
> Yes, I agree with you, the MSRP SEND request should be sent one  
> after each other. Bear in mind, also, that the idea of the draft is  
> to use MSRP "as is", with no changes.
>
> The examples section is inspired in the Examples Section 11 in the  
> MSRP draft,
>
> So, can you please point out if there are any suggestions for the  
> file transfer draft, or are those suggestions for MSRP? Especially,  
> I wouldn't dare to recommend to pipeline MSRP send requests or how  
> many of them, because as I said, we want to use off-the-shelf MSRP.  
> But perhaps you should post something in SIMPLE and to the MSRP  
> authors.
>
>>> A New Internet-Draft is available from the on-line Internet- 
>>> Drafts directories.
>>> To remove yourself from the I-D Announcement list, send a message  
>>> to [email-masked] with the word unsubscribe in the  
>>> body of the message. You can also visit https://www1.ietf.org/ 
>>> mailman/listinfo/I-D-announce to change your subscription settings.
>>>
>>> Internet-Drafts are also available by anonymous FTP. Login with  
>>> the username "anonymous" and a password of your e-mail address.  
>>> After logging in, type "cd internet-drafts" and then "get draft- 
>>> ietf-mmusic-file-transfer-mech-00.txt".
>>>
>>> http://www.ietf.org/shadow.html or ftp://ftp.ietf.org/ietf/ 
>>> 1shadow-sites.txt
>>>